﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
//using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Diagramming.Wpf;
using MindFusion.Diagramming.Wpf.Lanes;

namespace HeaderFocus
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();

			diagram.Bounds = new Rect(0, 0, 2000, 1000);

			Grid grid = diagram.LaneGrid;
			grid.RowCount = 10;
			grid.ColumnCount = 20;
			grid.ColumnHeadersHeights = new double[] { 50 };
			grid.RowHeadersWidths = new double[] { 50 };
			diagram.EnableLanes = true;

			FocusHeader(grid.RowHeaders[0]);

			diagram.PreviewKeyDown += new KeyEventHandler(diagram_PreviewKeyDown);
		}

		private void FocusHeader(Header header)
		{
			if (focusedHeader == header)
				return;

			if (focusedHeader != null)
				focusedHeader.Style = new MindFusion.Diagramming.Wpf.Lanes.Style()
				{
					BackgroundBrush = Brushes.White
				};

			focusedHeader = header;

			if (focusedHeader != null)
				focusedHeader.Style = new MindFusion.Diagramming.Wpf.Lanes.Style()
				{
					BackgroundBrush = Brushes.Yellow
				};
		}

		private void diagram_PreviewKeyDown(object sender, KeyEventArgs e)
		{
			int nextHeaderIndex = -1;
			if (e.Key == Key.Down)
			{
				if (focusedHeader != null)
					nextHeaderIndex = diagram.LaneGrid.GetRowIndex(focusedHeader) + 1;
				else
					nextHeaderIndex = 0;

				if (nextHeaderIndex >= diagram.LaneGrid.RowHeaders.Count)
					nextHeaderIndex = diagram.LaneGrid.RowHeaders.Count - 1;
			}
			else if (e.Key == Key.Up)
			{
				if (focusedHeader != null)
					nextHeaderIndex = diagram.LaneGrid.GetRowIndex(focusedHeader) - 1;
				else
					nextHeaderIndex = diagram.LaneGrid.RowHeaders.Count - 1;

				if (nextHeaderIndex < 0)
					nextHeaderIndex = 0;
			}

			if (nextHeaderIndex != -1)
				FocusHeader(diagram.LaneGrid.RowHeaders[nextHeaderIndex]);
		}


		private Header focusedHeader;
	}
}
